<?php
namespace Model;

use Stub\TrainingRepository;

abstract class Coach extends Role {

    public abstract function __construct(?TrainingRepository $trainingRepository);

    public abstract function getUsersList(): ?array;
    public abstract function getUserList(User $user): \Model\User;
    public abstract function getTraining(): ?TrainingRepository;
    public abstract function getTrainingsList(): ?array;
    public abstract function getTrainingList(Training $training): ?Training;


    public abstract function CheckAdd(User $user) : bool;
    public abstract function CheckAddTraining(Training $training) : bool;
    public abstract function addUser(User $user): bool;
    public abstract function removeUser(User $user): bool;
    public abstract function addTraining(Training $training): bool;
    public abstract function removeTraining(Training $training): bool;
}

?>