<?php

namespace Model;

use Stub\TrainingRepository;

class CoachAthlete extends Coach {

    public function __construct(?TrainingRepository $trainingRepository) {
        $this->trainingRepository = $trainingRepository;
    }
    public function getUsersList(): ?array {
        if (!empty($this->usersList)) {
            return $this->usersList;
        }
        return null;
    }
    public function getUserList(User $user): User {
        foreach ($this->usersList as $existingUser) {
            if ($existingUser->getId() === $user->getId()) {
                return $existingUser; // L'utilisateur est présent dans la liste
            }
        }
        return null; // L'utilisateur n'est pas dans la liste
    }
    public function getTraining(): TrainingRepository {
        return $this->trainingRepository;
    }
    public function getTrainingsList(): ?array {
        if (!empty($this->trainingRepository->getTrainingsList())) {
            return $this->trainingRepository->getTrainingsList();
        }
        return null;
    }
    public function getTrainingList(Training $training): ?Training {
        foreach ($this->trainingRepository->getTrainingsList() as $existingTraining) {
            if ($existingTraining->getId() === $training->getId()) {
                return $existingTraining; // L'utilisateur est présent dans la liste
            }
        }
        return null; // L'utilisateur n'est pas dans la liste
    }
    public function CheckAdd(User $user) : bool {
        if($user->getRole() instanceof \Model\Athlete){
            return true;
        }
        return false;
    }
    public function CheckAddTraining(Training $training) : bool {
        if($training instanceof \Model\Training){
            return true;
        }
        return false;
    }
    public function addUser(User $user): bool {
        if($this->CheckAdd($user)){
            array_push($this->usersList, $user);
            return true;
        }
        return false;
    }
    public function removeUser(User $user): bool {
        if($this->CheckAdd($user)){
            $key = array_search($user, $this->usersList);
            if ($key !== false) {
                array_splice($this->usersList, $key, 1);
                return true;
            }
        }
        return false;
    }
    public function addTraining(Training $training): bool {
        if($this->CheckAddTraining($training)){
            $this->trainingRepository->getTrainingsList()[] = $training;
            return true;
        }
        return false;
    }
    public function removeTraining(Training $training): bool {
        if($this->CheckAddTraining($training)){
            $array = (array)$this->trainingRepository->getTrainingsList();
            $key = array_search($training, $array);
            if ($key !== false) {
                array_splice($array, $key, 1);
                $this->trainingRepository->setTrainingsList($array);
                return true;
            }
        }
        return false;
    }
}