<?php

namespace Stub;

use Model\Athlete;
use Model\CoachAthlete;
use Model\Training;
use Model\User;
use Repository\ITrainingRepository;

class TrainingRepository implements ITrainingRepository {
    private array $trainingsList = [];

    public function __construct() {
        $this->trainingsList[] = new Training(1, new \DateTime("1985-05-10"), 48.5, 55.8, "john.doe@example.com", "hello");
        $this->trainingsList[] = new Training(2, new \DateTime("1986-06-12"), 48.5, 55.8, "john.doe@exavdffgmple.com", "hedfdffllo");
        $this->trainingsList[] = new Training(3, new \DateTime("1989-07-14"), 48.5, 55.8, "john.doe@exdfdfample.com", "hedfdfllo");
        $this->trainingsList[] = new Training(4, new \DateTime("1990-08-16"), 48.5, 55.8, "john.doe@exdfdfample.com", "hedffhdllo");
        $this->trainingsList[] = new Training(5, new \DateTime("2000-09-18"), 48.5, 55.8, "john.doe@exdffdample.com", "hedfdfgllo");
    }

    /**
     * @return array
     */
    public function &getTrainingsList(): array {
        return $this->trainingsList;
    }

    public function setTrainingsList(array $trainingsList): void {
        $this->trainingsList = $trainingsList;
    }

    public function getItemById(int $id): ?Training {
        foreach ($this->trainingsList as $training) {
            if ($training->getId() === $id) {
                return $training;
            }
        }
        return null;
    }

    public function GetNbItems(): int {
        return count($this->trainingsList);
    }

    public function GetItems(int $index, int $count, ?string $orderingPropertyName = null, bool $descending = false): array {
        // Cette méthode est un exemple simple, on ne gère pas l'ordonnancement ici
        return array_slice($this->trainingsList, $index, $count);
    }


    // should have type here
    public function UpdateItem($oldTraining, $newTraining): void {
        $index = array_search($oldTraining, $this->trainingsList);
        if ($index !== false) {
            $this->trainingsList[$index] = $newTraining;
        }
    }

    // should have type here
    public function AddItem($training): void {
        $this->trainingsList[] = $training;
    }

    // should have type here
    public function DeleteItem($training): bool {
        $index = array_search($training, $this->trainingsList);
        if ($index !== false) {
            unset($this->trainingsList[$index]);
            return true;
        }
        return false;
    }

    public function GetItemsByName(string $substring, int $index, int $count, ?string $orderingPropertyName = null, bool $descending = false): ?array
    {
        return null;
        // TODO: Implement GetItemsByName() method.
    }

    public function GetItemByName(string $substring, int $index, int $count, ?string $orderingPropertyName = null, bool $descending = false)
    {
        return null;
        // TODO: Implement GetItemByName() method.
    }
}